import refreshTokenHelper from "../../../utils/refreshTokenHelper"
import getTokenHelper from "../../../utils/getTokenHelper"
import forceLogoutHelper from "../../../utils/forceLogoutHelper"
import errorHandlingHelper from "../../../utils/errorHandlingHelper"
import fetchHelper from "../../../utils/fetchHelper"

const handleFunc = async (event: any, authToken: any = null) => {
  let data: any = {}
  const config = useRuntimeConfig()
  const token = authToken ?? await getTokenHelper(event)
  const body = await readBody(event)

  const res: any = await fetchHelper(event, 'models/m_pricelist', 'POST', token, {
    AD_Org_ID: {
      id: body.organizationId,
      tableName: 'AD_Org'
    },
    isActive: body.isActive,
    name: body.name,
    description: body.description,
    isSOPriceList: body.isSOPriceList,
    enforcePriceLimit: body.enforcePriceLimit,
    isTaxIncluded: body.isTaxIncluded,
    isDefault: body.isDefault,
    pricePrecision: body.pricePrecision,
    isPresentForProduct: body.isPresentForProduct,
    isMandatory: body.isMandatory,
    C_Currency_ID: {
      id: body.currencyId,
      tableName: 'C_Currency'
    },
    BasePriceList_ID: {
      id: body.basePriceListId,
      tableName: 'M_Pricelist'
    },
    tableName: 'M_Pricelist'
  })
  if(res) {
    data = res
    data['status'] = 200
    data['message'] = ''
  }

  return data
}

export default defineEventHandler(async (event) => {
  let data: any = {}

  try {
    data = await handleFunc(event)
  } catch(err: any) {
    try {
      let authToken: any = await refreshTokenHelper(event)
      data = await handleFunc(event, authToken)
    } catch(error: any) {
      data = errorHandlingHelper(err?.data ?? err, error?.data ?? error)
      forceLogoutHelper(event, data)
    }
  }

  return data
})